#include <iostream>
#define u unsigned

using namespace std;

int main() {
    
    int n, q; cin >> n >> q;
    u int dani[300], kupljeni[300], pojedeni[300];
    for (int i = 0; i < n; i++) {
        cin >> dani[i] >> kupljeni[i];
    }
    for (int k = 0; k < q; k++) {
        int kraj; cin >> kraj;
        pojedeni[0] = 1;
        for (int i = 0; i < n - 1; i++) {
            if (i > 0)kupljeni[i] += kupljeni[i - 1];
            if (dani[i + 1] - dani[i] < kupljeni[i])
                pojedeni[i + 1] = dani[i + 1] - dani[i];
            else {
                pojedeni[i + 1] += kupljeni[i] - pojedeni[i];
            }
        }
        if (kraj - dani[n - 1] > kupljeni[n - 1]) pojedeni[n - 1] = kupljeni[n - 1];
        else {
            pojedeni[n - 1] = kupljeni[n - 2] + kraj - dani[n - 1];
        }
        cout << pojedeni[n - 1] + 1 << '\n';
    }
    
    return 0;
}